<%@ page import="com.synametrics.xeams.rulesengine.*" %>
<%@ page import="java.util.*" %>

<%@ include file="PageHeader.jsp" %>
<%@ include file="SecondPageHeader.jsp" %>
<table width="100%" border="0" cellpadding="0" cellspacing="0">
    <tr align="left" valign="top">
    <td>
<table width="100%" border="0" cellspacing="2" cellpadding="4"><tr><td>

<%
int[][] bayesianBottom = (int[][])request.getSession().getAttribute("BayesianBottom");

String autoShrinkEnabled = (String)request.getAttribute("AutoShrinkEnabled");
if(autoShrinkEnabled == null) autoShrinkEnabled = "";

String occurrenceCount = (String)request.getAttribute("AutoShrinkOccurrenceCount");
String bayesianWordCount = (String)request.getAttribute("AutoShrinkWordCount");
String totalWordsInBayesianDB = (String)request.getAttribute("TotalWordsInBayesianDB");

%>
<%@ include file="RedBorderTableTop.jsp" %>
Bayesian Database Analysis
<%@ include file="RedBorderTableMiddle.jsp" %>

The number of bayesian filters can grow to a large number over time. If you see too much
memory being used by <%= productName %>, you might want to shrink the bayesian database. We recommend
that you shrink this database if the number of filters go over 1,000,000.

<p>
    Currently there are <b><%=totalWordsInBayesianDB%></b> words in the Bayesian database.
</p>
<p>
    The graph below shows the word distribution in the bayesian database.<br />
    <img alt="Bayesian Trimming Analysis" src="ImageController?operation=9" />
</p>
<h2>What does this mean?</h2>

The above graph shows that:

There are <%=bayesianBottom[0][1]%> words that occurred only once and
<%=bayesianBottom[1][1]%> words that occurred twice in the past and so on.
The bayesian database can be trimmed by specifying the occurence count. Therefore,
if you specify the occurence count to be 1, you will delete <%=bayesianBottom[0][1]%>
words from the database.
<br /><br>
Notice that if as the occurrence count increases the incremental difference in word count decrease. Therefore,
you get most memory savings where occurence count is less than 10.


<%@ include file="RedBorderTableBottom.jsp" %>

<p>
</p>

<%@ include file="RedBorderTableTop.jsp" %>
Shink database
<%@ include file="RedBorderTableMiddle.jsp" %>
<form action="<%= request.getAttribute("appPath") %>" method="post">
    <table>
    	<tr>
            <td>Occurence Count for Trimming:</td>
            <td><input type="text" name="txtOC" value="5" size="4" /><br />
            The digit <b>"5"</b> means that every word that occurred less than or equal to 5 times in the past
            will get deleted. Many spammers use invalid words in their emails that do not repeat in other
            messages. Therefore, deleting words that seldom appear in emails shrinks the database with minimal
            change in the effectiveness of Bayesian filter.
            </td>
    	</tr>
        <tr>
            <td>&nbsp;</td>
            <td><input type="image" class="form_button" src="<%= imagePath %>button_blank.png"></td>
        </tr>
    </table>

    <input type="hidden" name="operation" value="95" />
</form>
<%@ include file="RedBorderTableBottom.jsp" %>

<p>
    </p>

<%@ include file="RedBorderTableTop.jsp" %>
Auto Shrinking
<%@ include file="RedBorderTableMiddle.jsp" %>
Enable auto-shrinking if you like <%= productName %> to automatically shrink bayesian database.

<form action="<%= request.getAttribute("appPath") %>" method="post">

<table>
	<tr>
        <td><b>Enable Auto Shrink:</b></td>
        <td><input type="checkbox" name="chkEnableAutoShrink" <%=autoShrinkEnabled%> /></td>
	</tr>

    <tr>
        <td><b>Shrink once word count reaches:</b></td>
        <td><input type="text" name="txtWordCount" value="<%=bayesianWordCount%>" /></td>
    </tr>

    <tr>
        <td><b>Delete words that appeared less than:</b></td>
        <td><input type="text" name="txtOccurenceCount"  value="<%=occurrenceCount%>"/></td>
    </tr>

    <tr>
        <td>&nbsp;        </td>
        <td><input type="submit" value="Save"/>        </td>
    </tr>

</table>

<input type="hidden" name="operation" value="96" />

</form>

<%@ include file="RedBorderTableBottom.jsp" %>

</td></tr></table>
	 </td>
    <%@ include file="InnerRightGrey.jsp" %>
	</tr>
</table>

<%@ include file="SecondPageFooter.jsp" %>
<%@ include file="PageFooter.jsp" %>
